/* convert_life_pattern_2.pl */


/*
This program is a version of
convert_life_pattern.pl, with
line_to_equations and lines_to_equations
modified so that they create X+1 and Y+1
terms instead of adding 1 to X and Y.
It is explained in my Dobbs Code Talk 
posting "Prolog as a Text-Hacking Language".
*/


convert_life_pattern( InputFile, PatternName ) :-
  read_file_to_lines( InputFile, Lines ),
  lines_to_equations( Lines, PatternName, 4, Eqns ),
  atom_concat( PatternName, '.exc', OutputFile ),
  tell( OutputFile ),
  flatten( Eqns, EqnsFlattened ),
  maplist( write_equation, EqnsFlattened ),
  told.


lines_to_equations( [], _PatternName, _Y, [] ) :- !.

lines_to_equations( [ Line | Lines ], PatternName, Y, [ Eqns | MoreEqns ] ) :-
  line_to_equations( Line, PatternName, 4, Y, Eqns ),
  lines_to_equations( Lines, PatternName, Y+1, MoreEqns ).


line_to_equations( [], _PatternName, _X, _Y, [] ) :- !.

line_to_equations( [ 0'* | Rest ], PatternName, X, Y, [ Eqn | Eqns ] ) :- !,
  Eqn = eqn( PatternName, X, Y ),
  line_to_equations( Rest, PatternName, X+1, Y, Eqns ).

line_to_equations( [ 0'. | Rest ], PatternName, X, Y, Eqns ) :-
  line_to_equations( Rest, PatternName, X+1, Y, Eqns ).


write_equation( eqn( PatternName, X, Y ) ) :-
  format( '~w[~w,~w] = "n".~n', [PatternName,X,Y] ). 


read_file_to_lines( File, Lines ) :-
  open( File, read, Stream, [] ),
  read_line_to_codes( Stream, Line ),
  read_stream_to_lines( Line, Stream, Lines ),
  close( Stream ).


read_stream_to_lines( end_of_file, _Stream, [] ) :- !.

read_stream_to_lines( Line, Stream, [ Line | Rest ] ) :- 
  read_line_to_codes( Stream, NextLine ),
  read_stream_to_lines( NextLine, Stream, Rest ).



